'****************************************************************
'*  Name    : Test1_24C256_25K20.BAS                            *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 09/03/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the 24LC256 I2C eeprom memory             *
'****************************************************************

'    Include "D:/MyIncFiles/Amicus18_25K20.inc"
    Include "Amicus18_25K20.inc"

'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
'    Declare Show_System_Variables = On
'    Declare MemWrite_Int_Control = 1
'-------------------------------------------------------------------------------
' Declare Pins for I2C BUSin and Software_I2C.Inc

    Declare SDA_Pin = PORTC.4          ' SDA connected to this pin
    Declare SCL_Pin = PORTC.3          ' SCL connected to this pin
    Declare Hbus_Bitrate 400           ' Bus frequency 400kHz 
    Declare Slow_Bus On  

'===============================================================================
    Dim ReturnACK As Byte 
    Dim MyString0 As String * 8
    Dim MyString1 As String * 8
    Dim MyString2 As String * 8
    Dim MyString3 As String * 8    
    Dim MyString4 As String * 8
    Dim MyString5 As String * 8    
    Dim MyString6 As String * 8        
    Dim MyString7 As String * 8
    Dim MyString8 As String * 8
    
    Dim MyString9  As String * 64 
    Dim MyString10 As String * 64    
    Dim MyString11 As String * 64
    Dim MyString12 As String * 64    
    Dim MyString13 As String * 64    
        
    Dim MyDevice As Byte
    Dim ResultByte As Byte
    Dim E2PAddress As Word
    Dim ReturnNACK As Byte
    Dim aData As Byte
    Dim MyPage As Word   
'===============================================================================
' Uncomment the next line to disable the NACK function.
'$define _DisableNACK_

' Library for the 24LC256 external I2C eeprom memory. 
    $define _EnableGIE_Save_

$ifdef _EnableGIE_Save_
    @#define __INTERRUPTS_ENABLED 1
$endif

'    Include "D:/MyIncFiles/24LC256_H.inc"
    Include "24LC256_H.inc"

'    Include "D:/MyIncFiles/24LC256_S.inc"
'    Include "24LC256_S.inc"    
'-------------------------------------------------------------------------------
'=============================================================================== 
INIT_24LC256:
    DelayMS 250
    HRSOut "Running the Test1_24C256.bas file", CR
    HRSOut "TESTING THE 24C256 EEPROM MEMORY",CR,CR
'===============================================================================
    E2PAddress = 1000
    MyDevice = 0

    M24LC256_Present(0, ReturnNACK) 
    If ReturnNACK = 0 Then
        HRSOut "The 24LC256 memory number 0 is present", CR
    Else
        HRSOut "The 24LC256 memory number 0 fails or not connected", CR    
        Stop
    EndIf
    HRSOut CR
'-------------------------------------------------------------------------------
    aData = "A"
    HRSOut "Writing 1 Byte: A", CR

    ' WriteByte_E2(NumberOfDevice(Byte), Address(Word), DataOut(Byte), ReturnACK(Byte))  
    ' ReturnACK is not mandatory.
    WriteByte_E2P(MyDevice, E2PAddress, aData)

    ' Var1 = ReadByte_E2(NumberOfDevice(Byte), Address(Word), ReturnACK(Byte))   
    ' ReturnACK is not mandatory.
    aData = ReadByte_E2P(MyDevice, E2PAddress)

    HRSOut "Reading 1 Byte: ", aData, CR, CR
'-------------------------------------------------------------------------------

    HRSOut "Writing 8 pages of 8 Bytes (8 bytes x Page)", CR
    MyString0 = "00000000"
    MyString1 = "12345678"
    MyString2 = "90ABCDEF"    
    MyString3 = "GHIJKLMN"
    MyString4 = "PQRSTVWX"
    MyString5 = "1AAAAAA1"
    MyString6 = "2BBBBBB2"    
    MyString7 = "3CCCCCC3"

    HRSOut "WRITE...", CR
    HRSOut MyString0, CR
    HRSOut MyString1, CR 
    HRSOut MyString2, CR
    HRSOut MyString3, CR    
    HRSOut MyString4, CR
    HRSOut MyString5, CR 
    HRSOut MyString6, CR
    HRSOut MyString7, CR    
    HRSOut CR 

    MyDevice = 0
    ' WritePage_E2P8(NumberOfDevice(Byte), OutPutArray(Name), NumberPage(Byte), ReturnACK(Byte))    
    ' ReturnACK is not mandatory.
    WritePage_E2P8(MyDevice, MyString0, 0)
    WritePage_E2P8(MyDevice, MyString1, 1)
    WritePage_E2P8(MyDevice, MyString2, 2)
    WritePage_E2P8(MyDevice, MyString3, 3)  
    WritePage_E2P8(MyDevice, MyString4, 4)
    WritePage_E2P8(MyDevice, MyString5, 5)
    WritePage_E2P8(MyDevice, MyString6, 6)
    WritePage_E2P8(MyDevice, MyString7, 7)  

'-------------------------------------------------------------------------------
    HRSOut "Writing 4 pages of 64 Bytes (64 bytes x Page)", CR
    MyString10 = "ABCDEFGH,HGFEDCBA,66666666,77777777,88888888,5AAAAAA5,7VVVVVV7AA"
    MyString11 = "88888888,11111111,22222222,33333333,44444444,55555555,66666666BB"    
    MyString12 = "11111111,22222222,33333333,44444444,55555555,66666666,77777777CC" 
    MyString13 = "77777777,88888888,99999999,00000000,AAAAAAAA,CCCCCCCC,DDDDDDDDEE" 

    HRSOut MyString10, CR
    HRSOut MyString11, CR 
    HRSOut MyString12, CR
    HRSOut MyString13, CR  
    HRSOut CR    

    MyDevice = 0
    ' WritePage_E2P64(NumberOfDevice(Byte), OutPutArray(Name), NumberPage(Byte), ReturnACK(Byte))   
    ' ReturnACK is not mandatory.
    WritePage_E2P64(MyDevice, MyString10, 1)
    WritePage_E2P64(MyDevice, MyString11, 2)
    WritePage_E2P64(MyDevice, MyString12, 3)
    WritePage_E2P64(MyDevice, MyString13, 4)
'-------------------------------------------------------------------------------

    Clear MyString0
    Clear MyString1    
    Clear MyString2
    Clear MyString3    
    Clear MyString4    
    Clear MyString5
    Clear MyString6
    Clear MyString7    

    ' ReadPage_E2P8(NumberOfDevice(Byte), InputArray(Name), NumberPage(Byte), ReturnACK(Byte))
    ' ReturnACK is not mandatory.         
    ReadPage_E2P8(MyDevice, MyString0, 0)
    ReadPage_E2P8(MyDevice, MyString1, 1)
    ReadPage_E2P8(MyDevice, MyString2, 2)
    ReadPage_E2P8(MyDevice, MyString3, 3)    
    ReadPage_E2P8(MyDevice, MyString4, 4)
    ReadPage_E2P8(MyDevice, MyString5, 5)
    ReadPage_E2P8(MyDevice, MyString6, 6)
    ReadPage_E2P8(MyDevice, MyString7, 7) 
       
    HRSOut "Reading 8 pages of 8 Bytes (8 bytes x Page)", CR
    HRSOut MyString0, CR 
    HRSOut MyString1, CR
    HRSOut MyString2, CR    
    HRSOut MyString3, CR   
    HRSOut MyString4, CR 
    HRSOut MyString5, CR
    HRSOut MyString6, CR    
    HRSOut MyString7, CR 
    HRSOut CR

    Clear MyString9
    Clear MyString10
    Clear MyString11    
    Clear MyString12
    Clear MyString13  

    ' ReadPage_E2P64(NumberOfDevice(Byte), InputArray(Name), NumberPage(Byte), ReturnACK(Byte))   
    ' ReturnACK is not mandatory.
    ReadPage_E2P64(MyDevice, MyString9,  0, ReturnACK)
    ReadPage_E2P64(MyDevice, MyString10, 1, ReturnACK)
    ReadPage_E2P64(MyDevice, MyString11, 2, ReturnACK)
    ReadPage_E2P64(MyDevice, MyString12, 3, ReturnACK)
    ReadPage_E2P64(MyDevice, MyString13, 4, ReturnACK)

    HRSOut "Reading 1 page of 64 Bytes from Page0 (64 bytes x Page)", CR   
    HRSOut MyString9, CR, CR 
    HRSOut "Reading 4 pages of 64 Bytes from Page1 (64 bytes x Page)", CR
    HRSOut MyString10, CR 
    HRSOut MyString11, CR
    HRSOut MyString12, CR    
    HRSOut MyString13, CR 
    HRSOut CR
'===============================================================================
    End    
'===============================================================================
   
