'****************************************************************
'*  Name    : Test2_24C256_25K20.BAS                            *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/01/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the 24LC256 I2C eeprom memory             *
'*          : Using software I2C (I2COut/I2CIn) commands        *
'****************************************************************

'    Include "D:/MyIncFiles/Amicus18_25K20.inc"
    Include "Amicus18_25K20.inc"

'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
'    Declare Show_System_Variables = On
'    Declare MemWrite_Int_Control = 1
'===============================================================================
    Dim MyString0 As String * 8
    Dim MyString1 As String * 8
    Dim MyString2 As String * 8
    Dim MyString3 As String * 8    
    Dim MyString4 As String * 8
    Dim MyString5 As String * 8    
    Dim MyString6 As String * 8        
    Dim MyString7 As String * 8
    Dim MyString8 As String * 8
    
    Dim MyString9  As String * 64 
    Dim MyString10 As String * 64    
    Dim MyString11 As String * 64
    Dim MyString12 As String * 64    
    Dim MyString13 As String * 64    
        
    Dim MyDevice As Byte
    Dim E2PAddress As Word
    Dim aData As Byte
    Dim MyPage As Word
    Dim ReturnACK As Byte   
'===============================================================================
' Declare Pins for Software I2C
    Declare SDA_Pin PORTC.4          ' SDA connected to this pin
    Declare SCL_Pin PORTC.3          ' SCL connected to this pin
'    Declare Hbus_Bitrate 400         ' Bus frequency 400kHz
'    Declare Slow_Bus On 

' Uncomment the next line to disable the NACK function.
'$define _DisableNACK_

' Library for the 24LC256 external I2C eeprom memory. 
'    $define _EnableGIE_Save_

$ifdef _EnableGIE_Save_
    @#define __INTERRUPTS_ENABLED 1
$endif

'    Include "D:/MyIncFiles/24LC256_S2.inc"
    Include "24LC256_S2.inc" 
'-------------------------------------------------------------------------------
'=============================================================================== 
INIT_24LC256:
    DelayMS 250
    HRSOut "Test2_24C256.bas file", CR
    HRSOut "TESTING THE 24C256 EEPROM MEMORY WITH I2COut/I2CIn",CR,CR
'===============================================================================

    E2PAddress = 1000
    MyDevice = 0
'-------------------------------------------------------------------------------

    M24LC256_Present(0, ReturnACK) 
    If ReturnACK = 0 Then
        HRSOut "The 24LC256 memory number 0 is present", CR
    Else
        HRSOut "The 24LC256 memory number 0 fails or not connected", CR    
        Stop
    EndIf
    HRSOut CR
'-------------------------------------------------------------------------------
    aData = "A"
    HRSOut "Writing 1 Byte: A", CR
    WriteByte_E2P(MyDevice, E2PAddress, aData)

    aData = ReadByte_E2P(MyDevice, E2PAddress)
    HRSOut "Reading 1 Byte: ", aData, CR, CR

'-------------------------------------------------------------------------------
    HRSOut "Writing 8 pages of 8 Bytes (8 bytes x Page)", CR
    MyString0 = "00000000"
    MyString1 = "12345678"
    MyString2 = "90ABCDEF"    
    MyString3 = "GHIJKLMN"
    MyString4 = "PQRSTVWX"
    MyString5 = "1AAAAAA1"
    MyString6 = "2BBBBBB2"    
    MyString7 = "3CCCCCC3"

    HRSOut "WRITE...", CR
    HRSOut MyString0, CR
    HRSOut MyString1, CR 
    HRSOut MyString2, CR
    HRSOut MyString3, CR    
    HRSOut MyString4, CR
    HRSOut MyString5, CR 
    HRSOut MyString6, CR
    HRSOut MyString7, CR    
    HRSOut CR 

    MyDevice = 0
    ' WriteBlock_E2P(Number of Device(Byte), Input Array(Name), Number Block(Byte), Return ACK(Byte))    
WritePage8:
    WritePage_E2P8(MyDevice, MyString0, 0)
    WritePage_E2P8(MyDevice, MyString1, 1)
    WritePage_E2P8(MyDevice, MyString2, 2)
    WritePage_E2P8(MyDevice, MyString3, 3)  
    WritePage_E2P8(MyDevice, MyString4, 4)
    WritePage_E2P8(MyDevice, MyString5, 5)
    WritePage_E2P8(MyDevice, MyString6, 6)
    WritePage_E2P8(MyDevice, MyString7, 7)  

'-------------------------------------------------------------------------------
    HRSOut "Writing 4 pages of 64 Bytes (64 bytes x Page)", CR
    MyString10 = "AAAAAAAA,CCCCCCCC,EEEEEEEE,QQQQQQQQ,RXXXXXXR,2AAAAAA2,5BBBBBB5BB"
    MyString11 = "88888888,11111111,22222222,33333333,44444444,55555555,66666666CC"    
    MyString12 = "11111111,22222222,33333333,44444444,55555555,66666666,77777777DD" 
    MyString13 = "77777777,88888888,99999999,00000000,AAAAAAAA,CCCCCCCC,DDDDDDDDFF" 

    HRSOut MyString10, CR
    HRSOut MyString11, CR 
    HRSOut MyString12, CR
    HRSOut MyString13, CR  
    HRSOut CR    

    MyDevice = 0
WritePage64:
    WritePage_E2P64(MyDevice, MyString10, 1)
    WritePage_E2P64(MyDevice, MyString11, 2)
    WritePage_E2P64(MyDevice, MyString12, 3)
    WritePage_E2P64(MyDevice, MyString13, 4)
'-------------------------------------------------------------------------------

    Clear MyString0
    Clear MyString1    
    Clear MyString2
    Clear MyString3    
    Clear MyString4    
    Clear MyString5
    Clear MyString6
    Clear MyString7    

ReadPage8:        
    ReadPage_E2P8(MyDevice, MyString0, 0)
    ReadPage_E2P8(MyDevice, MyString1, 1)
    ReadPage_E2P8(MyDevice, MyString2, 2)
    ReadPage_E2P8(MyDevice, MyString3, 3)    
    ReadPage_E2P8(MyDevice, MyString4, 4)
    ReadPage_E2P8(MyDevice, MyString5, 5)
    ReadPage_E2P8(MyDevice, MyString6, 6)
    ReadPage_E2P8(MyDevice, MyString7, 7) 
       
    HRSOut "Reading 8 pages of 8 Bytes (8 bytes x Page)", CR
    HRSOut MyString0, CR 
    HRSOut MyString1, CR
    HRSOut MyString2, CR    
    HRSOut MyString3, CR   
    HRSOut MyString4, CR 
    HRSOut MyString5, CR
    HRSOut MyString6, CR    
    HRSOut MyString7, CR 
    HRSOut CR

    Clear MyString9
    Clear MyString10
    Clear MyString11    
    Clear MyString12
    Clear MyString13  

ReadPage64:
    ReadPage_E2P64(MyDevice, MyString9,  0)
    ReadPage_E2P64(MyDevice, MyString10, 1)
    ReadPage_E2P64(MyDevice, MyString11, 2)
    ReadPage_E2P64(MyDevice, MyString12, 3)
    ReadPage_E2P64(MyDevice, MyString13, 4)



    HRSOut "Reading 1 page of 64 Bytes from Page0 (64 bytes x Page)", CR   
    HRSOut MyString9, CR, CR 
    HRSOut "Reading 4 pages of 64 Bytes from Page1 (64 bytes x Page)", CR
    HRSOut MyString10, CR 
    HRSOut MyString11, CR
    HRSOut MyString12, CR    
    HRSOut MyString13, CR 
    HRSOut CR
'===============================================================================
    End    
'===============================================================================
   
