'****************************************************************
'*  Name    : Test1_24C256_25K20.BAS                            *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/01/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the 24LC256 I2C eeprom memory             *
'*          : Using software I2C (I2COut/I2CIn) commands        *
'****************************************************************

'    Include "D:/MyIncFiles/Amicus18_25K20.inc"
    Include "Amicus18_25K20.inc"

'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
'    Declare Show_System_Variables = On
'    Declare MemWrite_Int_Control = 1
'===============================================================================
    Dim MyString0 As String * 128
        
    Dim MyDevice As Byte
    Dim E2PAddress As Word
    Dim aData As Byte
    Dim MyPage As Word
    Dim ReturnNACK As Byte   
'===============================================================================
' Declare Pins for Software I2C
    Declare SDA_Pin PORTC.4          ' SDA connected to this pin
    Declare SCL_Pin PORTC.3          ' SCL connected to this pin
    Declare Hbus_Bitrate 400         ' Bus frequency 400kHz 
    Declare Slow_Bus On  

' Uncomment the next line to disable the NACK function.
$define _DisableNACK_

' Library for the 24LC256 external I2C eeprom memory. 
'    $define _EnableGIE_Save_

' Uncomment this line for testing with interrupts
$ifdef _EnableGIE_Save_
    @#define __INTERRUPTS_ENABLED 1
$endif

    $define _24LC512_    
'    Include "D:/MyIncFiles/24LC256_H.inc"
'    Include "24LC256_H.inc"
'    Include "D:/MyIncFiles/24LC256_S.inc"
    Include "24LC256_S.inc"    
'-------------------------------------------------------------------------------
'=============================================================================== 
INIT_24LC256:
    DelayMS 250
    HRSOut "Test3_24C256.bas file", CR
    HRSOut "TESTING THE 24C512 EEPROM MEMORY",CR,CR
'===============================================================================
    MyDevice = 0
    MyPage = 0

    M24LC512_Present(0, ReturnNACK) 
    If ReturnNACK = 0 Then
        HRSOut "The 24LC512 memory number 0 is present", CR
    Else
        HRSOut "The 24LC512 memory number 0 fails or not connected", CR    
        Stop
    EndIf
    HRSOut CR
'-------------------------------------------------------------------------------
    HRSOut "Writing 1 page of 128 Bytes (128 bytes x Page)", CR
    MyString0 = "00000000,12345678,90ABCDEF,GHIJKLMN,PQRSTVWX,1AAAAAA1,2BBBBBB2..88888888,11111111,22222222,33333333,44444444,55555555,66666666.."

    HRSOut MyString0, CR
    HRSOut CR 

    WritePage_E2P128(MyDevice, MyString0, MyPage)

'-------------------------------------------------------------------------------
MAIN_C256:

    Clear MyString0
        
    ReadPage_E2P128(MyDevice, MyString0, MyPage)
       
    HRSOut "Reading 1 page of 128 Bytes (128 bytes x Page)", CR
    HRSOut MyString0, CR 
    HRSOut CR

'===============================================================================
    End    
'===============================================================================
   
